program getnumthreads

  implicit none
  
  INTEGER :: nthreads,idx
  
  nthreads=-1
  
  CALL get_num_threads(nthreads)
  
  PRINT *, "----------"
  PRINT *, "Serial region  ",nthreads
  PRINT *
  !$OMP PARALLEL PRIVATE(nthreads,idx)
  
  idx=0
  CALL get_num_threads(nthreads)
  CALL get_thread_id(idx)
  
  !$OMP SINGLE
  PRINT *, "Outer parallel ",nthreads
  PRINT *
  !$OMP END SINGLE

  !$OMP PARALLEL NUM_THREADS(idx+1) PRIVATE(idx,nthreads)
  CALL get_num_threads(nthreads)
  !$OMP SINGLE
  PRINT *, "Inner parallel ",nthreads
  !$OMP END SINGLE
  !$OMP END PARALLEL
  
  !$OMP BARRIER
  !$OMP SINGLE
  PRINT *, "----------"
  !$OMP END SINGLE
  
  !$OMP END PARALLEL
end program getnumthreads

SUBROUTINE get_num_threads(threads)
  IMPLICIT NONE 
  integer :: threads
  threads = -1
END SUBROUTINE get_num_threads

SUBROUTINE get_thread_id(idx)
  IMPLICIT NONE
  INTEGER :: idx
  idx = -1  
END SUBROUTINE get_thread_id
